##  for PCLinuxOS  ##

%define ver 1.5.28
%define rel 1

%define api 1.0
%define major 5
%define libname %mklibname %{name} %{api} %{major}

%define gtk_binary_version %(pkg-config --variable=gtk_binary_version gtk+-2.0)
%define gtk3_binary_version %(pkg-config --variable=gtk_binary_version gtk+-3.0)


Name:    ibus
Summary: A next generation intelligent input bus for Linux/Unix
Summary(ja): IBus インプットメソッドフレームワーク
Version: %{ver}
Release: %{rel}.nora23
Group:   System/Internationalization
License: LGPLv2+
URL:     https://github.com/ibus/ibus/wiki

Source0: https://github.com/ibus/ibus/archive/ibus-%{version}.tar.gz
Source1: ibus.macros

BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: python3-devel
BuildRequires: python-gobject3-devel
BuildRequires: gtk+2-devel
BuildRequires: gtk+3-devel
BuildRequires: gtk4-devel
BuildRequires: dbus-glib-devel
BuildRequires: python-dbus-devel
BuildRequires: iso-codes-devel
BuildRequires: gettext-devel
BuildRequires: gtk-doc
BuildRequires: lib64dconf-devel
BuildRequires: lib64girepository-devel
BuildRequires: vala-devel
BuildRequires: glib2-devel
BuildRequires: libnotify-devel
BuildRequires: X11-devel
BuildRequires: libxkbfile-devel
BuildRequires: desktop-file-utils
BuildRequires: dbus-x11
#BuildRequires: GConf2
BuildRequires: wayland-devel
#
BuildRequires: qt5gui-devel
BuildRequires: libxtst6-devel
#
BuildRequires: libjson-glib-devel
BuildRequires: cldr-emoji-annotation
BuildRequires: unicode-emoji
BuildRequires: unicode-ucd

Requires(postun): dconf
Requires(posttrans): dconf

Requires: %{libname} = %{version}-%{release}
#Requires: %%{name}-gtk = %%{version}-%%{release}
Requires: %{name}-gtk3 = %{version}-%{release}
Requires: %{name}-ui-gtk3 = %{version}-%{release}
Requires: python3-gobject3
Requires: python3-dbus
Requires: python3-notify2
Requires: python3-pyxdg
Requires: iso-codes
Requires: librsvg
Requires: dconf
Requires: x11-server >= 1.12.4
Requires: setime >= 1.5

Obsoletes: %{_lib}ibus-gir1.0

%description
IBus is an Intelligent Input Bus. It is a new input framework for Linux OS.
It provides full featured and user friendly input method user interface.
It also may help developers to develop input method easily.

%description -l ja
IBus は Unix/Linux の為の新しいインプットメソッドフレームワークです。

※ インストール後は IBus の再起動または再ログインを行ってください。

%posttrans
dconf update || :
[ -x %{_bindir}/ibus ] && %{_bindir}/ibus write-cache --system &>/dev/null || :

%postun
if [ $1 = 0 ]; then
# 'dconf update' sometimes does not update the db...
dconf update || :
[ -f %{_sysconfdir}/dconf/db/ibus ] && rm %{_sysconfdir}/dconf/db/ibus || :
# 'ibus write-cache --system' updates the system cache.
[ -f /var/cache/ibus/bus/registry ] && rm /var/cache/ibus/bus/registry || :
fi

# -------------------------------------------------------------------

%package -n %{libname}
Summary: Shared libraries for ibus
Group:   System/Internationalization

%description -n %{libname}
IBus shared libraries.

%post -n %{libname}
/sbin/ldconfig

%postun -n %{libname}
/sbin/ldconfig

# -------------------------------------------------------------------

%package gtk
Summary:  IBus gtk+2 module
Summary(ja): IBus の gtk+2 用モジュール
Group:    System/Internationalization
Requires: %{name} = %{version}-%{release}
Requires(post,postun): gtk+2.0

%description gtk
IBus gtk+2 module.

%description gtk -l ja
IBus の gtk+2 用モジュール

%post gtk
%{_libdir}/gtk-2.0/bin/gtk-query-immodules-2.0 --update-cache

%postun gtk
%{_libdir}/gtk-2.0/bin/gtk-query-immodules-2.0 --update-cache

# -------------------------------------------------------------------

%package gtk3
Summary:  IBus im module for gtk+3
Summary(ja): IBus の gtk+3 用モジュール
Group:    System/Internationalization
Requires: %{name} = %{version}-%{release}
Requires(post,postun): gtk+3.0

%description gtk3
The ibus-gtk3 contains ibus im module for gtk+3.

%description gtk3 -l ja
IBus の gtk+3 用モジュール

%post gtk3
gtk-query-immodules-3.0-%{__isa_bits} --update-cache

%postun gtk3
gtk-query-immodules-3.0-%{__isa_bits} --update-cache

# -------------------------------------------------------------------

%package ui-gtk3
Summary:  GTK+ 3.0 UI for IBus
Group:    System/Internationalization
Provides: ibus-ui
Requires: %{name} = %{version}-%{release}
Requires: %{name}-gtk3 = %{version}-%{release}

%description ui-gtk3
GTK+ 3.0 UI for IBus.

# -------------------------------------------------------------------

%package gtk4
Summary: IBus gtk4 module
Group:   System/Internationalization
Requires: %{name} = %{version}-%{release}

%description gtk4
IBus gtk4 module.

# -------------------------------------------------------------------

%package devel
Summary:  Headers of %{name} for development
Summary(ja): IBus のヘッダファイル
Group:    Development/C
Requires: %{name} = %{version}-%{release}
Requires: %{libname} = %{version}-%{release}

%description devel
IBus development package: static libraries, header files, and the like.

%description devel -l ja
IBus を使用したアプリケーションを開発するのに必要なファイル。

# -------------------------------------------------------------------

%prep
%setup -q -n %{name}-%{version}


%build
#autoreconf -ifv

%configure2_5x \
--libexecdir=%{_libdir} \
--enable-vala=yes \
--enable-gtk-doc \
--with-python=python3 --disable-python2 --disable-python-library \
--enable-wayland \
--enable-gtk4 \
--disable-dbus-python-check \
--disable-systemd-services

%make_build


%install
rm -rf $RPM_BUILD_ROOT
%makeinstall_std

## install rpm macro
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/rpm/macros.d/
install -m0644 %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/rpm/macros.d/%{name}.macros

## install .desktop files
desktop-file-install \
 --vendor="" \
 --add-category="X-MandrivaLinux-System-Configuration" \
 --dir $RPM_BUILD_ROOT%{_datadir}/applications $RPM_BUILD_ROOT%{_datadir}/applications/org.freedesktop.IBus.Setup.desktop

##
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/bash_completion.d/
mv -f $RPM_BUILD_ROOT%{_datadir}/bash-completion/completions/ibus.bash $RPM_BUILD_ROOT%{_sysconfdir}/bash_completion.d/

##
mkdir -p $RPM_BUILD_ROOT%{_datadir}/pixmaps
ln -sf %{_datadir}/icons/hicolor/48x48/apps/ibus-keyboard.png \
  $RPM_BUILD_ROOT%{_datadir}/pixmaps/ibus-keyboard.png

## remove unneeded files
find %buildroot -name '*.la' | xargs rm

%find_lang %{name}10


%files -f %{name}10.lang
%defattr(-,root,root)
%doc AUTHORS ChangeLog NEWS README COPYING
%{_sysconfdir}/bash_completion.d/ibus.bash
%{_sysconfdir}/dconf/db/ibus.d/00-upstream-settings
%{_sysconfdir}/dconf/profile/ibus
%{_sysconfdir}/xdg/Xwayland-session.d/10-ibus-x11
%{_bindir}/*
%{_libdir}/ibus-dconf
%{_libdir}/ibus-engine-simple
%{_libdir}/ibus-x11
%{_libdir}/ibus-ui-emojier
%{_libdir}/ibus-wayland
%{_libdir}/ibus-portal
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man7/*
%{_datadir}/applications/*.desktop
%{_datadir}/ibus/*
%{_datadir}/GConf/gsettings/ibus.convert
%{_datadir}/glib-2.0/schemas/org.freedesktop.ibus.gschema.xml
%{_datadir}/dbus-1/services/*.service
%{_datadir}/gettext/its/ibus.*
%{_datadir}/pixmaps/*
%{_iconsdir}/*/*/*/*
%{python3_sitearch}/gi/overrides/*
%exclude %{_datadir}/ibus/component/gtkpanel.xml

%files -n %{libname}
%defattr(-,root,root)
%{_libdir}/libibus-%{api}.so.%{major}
%{_libdir}/libibus-%{api}.so.%{major}.*
%{_libdir}/girepository-1.0/*.typelib

%files gtk
%defattr(-,root,root)
%{_libdir}/gtk-2.0/%{gtk_binary_version}/immodules/im-ibus.so

%files gtk3
%defattr(-,root,root)
%{_libdir}/gtk-3.0/%{gtk3_binary_version}/immodules/im-ibus.so

%files ui-gtk3
%defattr(-,root,root)
%{_libdir}/ibus-ui-gtk3
%{_libdir}/ibus-extension-gtk3
%{_datadir}/ibus/component/gtkpanel.xml

%files gtk4
%defattr(-,root,root)
%{_libdir}/gtk-4.0/*/immodules/*.so

%files devel
%defattr(-,root,root)
%{_includedir}/ibus-%{api}
%{_libdir}/libibus-%{api}.so
%{_libdir}/pkgconfig/ibus-%{api}.pc
%{_datadir}/gtk-doc/html/ibus/*
%{_datadir}/gir-%{api}/*.gir
%{_datadir}/vala/vapi/ibus-%{api}.*
%{_sysconfdir}/rpm/macros.d/ibus.macros


%changelog
* Wed Feb 22 2023 tomcat <> 1.5.28-1
- 1.5.28

* Tue Aug 23 2022 tomcat <> 1.5.27-1
- 1.5.27

* Tue Mar 15 2022 tomcat <> 1.5.26-1
- 1.5.26
- drop Patch0 merged upstream
- add build option '--disable-systemd-services'
- update %%files

* Mon Sep 20 2021 tomcat <> 1.5.25-1
- 1.5.25
- add Patch0:fix-wrong-cursor-location.patch

* Sat Apr 03 2021 tomcat <> 1.5.24-2
- create gtk4 im module
    * add BR:gtk4-devel
    * add build option '--enable-gtk4'

* Mon Mar 08 2021 tomcat <> 1.5.24-1
- 1.5.24
- drop Patch0 merged upstream
- now use system installed cldr-emoji-annotation, unicode-emoji, unicode-ucd
    * add BR:cldr-emoji-annotation, unicode-emoji, unicode-ucd
    * drop Source10,11,12
    * update configure option
    * update %%files

* Mon Jan 11 2021 tomcat <> 1.5.23-2
- rebuild

* Tue Oct 13 2020 tomcat <> 1.5.23-1
- 1.5.23
- update Source10:cldr-emoji-annotation to 37.0_13.0_0_2
- update Source11:unicode-emoji to 13.1
- update Source12:UCD.zip to 13.0.0
- add Patch0:Fix_arguments_in_GLib.DBusSignalCallback_for_Vala_0.50.patch

* Mon Feb 24 2020 tomcat <> 1.5.22-1
- 1.5.22
- drop Patch0 merged upstream
- update Source10:cldr-emoji-annotation to 36.12.120191002_0
- update Source11:unicode-emoji to 12.1

* Thu Sep 19 2019 tomcat <> 1.5.21-2
- use python3 instead of python2
- update %%files
- add Patch0 for fix CVE-2019-14822
    https://people.canonical.com/~ubuntu-security/cve/2019/CVE-2019-14822.html

* Tue Aug 27 2019 tomcat <> 1.5.21-1
- 1.5.21
- drop Patch10
- remove '--localedir=' configure option
- update %%files

* Tue Mar 12 2019 tomcat <> 1.5.20-2
- add '--localedir=' configure option due to ibus-setup is not localized

* Fri Mar 01 2019 tomcat <> 1.5.20-1
- 1.5.20
- update Source10:cldr-emoji-annotation to 34.12.14891_0
- drop Patch0 merged to 1.5.20

* Thu Feb 07 2019 tomcat <> 1.5.19-0.3
- add Patch0:ibus-HEAD.patch from Fedora
- update Source10:cldr-emoji-annotation to 34.0.0_0
- update Source11:unicode-emoji to 12.0

* Tue Aug 14 2018 tomcat <> 1.5.19-0.2
- rebuild against glib2-2.57.2

* Sun Aug 12 2018 tomcat <> 1.5.19-0.1
- 1.5.19
- update Source10 (cldr-emoji-annotation) to 33.1.0_0
- update Source12 (UCD.zip) to 11.0.0
- enable appindicator again
- update %%files

* Wed May 23 2018 tomcat <> 1.5.18-0.2.git20180511
- git.20180511
- drop Patch9 merged upstream
- update Source10 (cldr-emoji-annotation) to 33.0.0_1
- disable appindicator
    - remove BR:libappindicator3-devel

* Mon Mar 05 2018 tomcat <> 1.5.18-0.1
- 1.5.18
- drop Patch304, Patch308
- update %%files ui-gtk3
- enable unicode dict
    - add Source12 (UCD.zip)
    - add Patch9 for '--with-ucd-dir' option
    - add configure option '--with-ucd-dir'

* Mon Jan 15 2018 tomcat <> 1.5.17-0.2.git20180115
- git.20180115
- update Source10 (cldr-emoji-annotation) to 32.0.0_1
- update Source11 (unicode-emoji) to 11.0

* Mon Oct 23 2017 tomcat <> 1.5.17-0.1
- 1.5.17
- update Source10 (cldr-emoji-annotation) to 31.90.0_1
- update Source11 (unicode-emoji) to 6.0

* Wed Sep 27 2017 tomcat <> 1.5.16-0.5.git20170926
- update to gti.20170926

* Sat Sep 16 2017 tomcat <> 1.5.16-0.4.git20170915
- update to gti.20170915
- use libappindicator3-devel instead of libappindicator-devel
- update %%files

* Mon Jul 24 2017 tomcat <> 1.5.16-0.3
- add build option --with-no-snooper-apps=''

* Mon Jun 27 2017 tomcat <> 1.5.16-0.2
- require setime-1.5
- add Patch304, Patch308 again

* Sun May 21 2017 tomcat <> 1.5.16-0.1
- update to 1.5.16
- drop Patch304, Patch308
- remove 'make -C ui/gtk3 maintainer-clean-generic' from %%build section
- remove 'make -C tools maintainer-clean-generic' from %%build section
- enable emoji dict
    - add Source10:cldr-emoji-annotation-31.0.1_1.tar.gz
    - add Source11:unicode-emoji-4.0.tar.xz
    - add configure option '--with-emoji-annotation-dir'
    - add configure option '--with-unicode-emoji-dir'
    - update %%files section

* Sun Apr 09 2017 tomcat <> 1.5.15-0.3
- add 'make -C ui/gtk3 maintainer-clean-generic' into %%build section
- add 'make -C tools maintainer-clean-generic' into %%build section
- add 'R:%%{libname}' into ibus-gtk and ibus-gtk3 sub packages

* Sat Mar 11 2017 tomcat <> 1.5.15-0.2
- change configure option to '--disable-python-library' from '--enable-python-library' again

* Tue Mar 07 2017 tomcat <> 1.5.15-0.1
- update to 1.5.15

* Wed Feb 15 2017 tomcat <> 1.5.14-9.git20170213
- update to git.20170213

* Sun Feb 12 2017 tomcat <> 1.5.14-8.git20170206
- test build

* Sat Feb 11 2017 tomcat <> 1.5.14-7.git20170206
- update to git.20170206
- change configure option to '--enable-python-library' from '--disable-python-library' again
- update %%files

* Fri Feb 10 2017 tomcat <> 1.5.14-6.git20170127
- rebuild on KDE5
- enable appindicator

* Sat Jan 28 2017 tomcat <> 1.5.14-5.git20170127
- update to git.20170127

* Sat Jan 14 2017 tomcat <> 1.5.14-4.git20170111
- update to git.20170111

* Wed Nov 23 2016 tomcat <> 1.5.14-3.git20161012
- temporary disable appindicator

* Tue Nov 22 2016 tomcat <> 1.5.14-2.git20161012
- update to git.20161012

* Fri Aug 05 2016 tomcat <> 1.5.14-1
- update to 1.5.14
- fix typo in %%changelog

* Fri Aug 05 2016 tomcat <> 1.5.13-5.git20160804
- change configure option to '--disable-python-library' from '--enable-python-library'
- update %%files

* Thu Aug 04 2016 tomcat <> 1.5.13-4.git20160804
- update to git.20160804
- disabled emoji-dict

* Tue Jun 28 2016 tomcat <> 1.5.13-3.git20160623
- update to git.20160623
- add '--enable-emoji-dict' build option
- add BR:wget 

* Wed May 25 2016 tomcat <> 1.5.13-2.git20160525
- update to git.20160525
- update %%files section

* Tue Feb 23 2016 tomcat <> 1.5.13-1
- 1.5.13

* Wed Jan 20 2016 tomcat <> 1.5.12-1
- 1.5.12

* Mon Jan 11 2016 tomcat <> 1.5.11-7.git20151104
- drop Patch303 (show-input-mode-icon.patch), because of Mozc fix this issue in 2.17.2313.102

* Mon Dec 28 2015 tomcat <> 1.5.11-6.git20151104
- fix %%post and %%postun in ibus-gtk, due to typo in /usr/bin/gtk-query-immodules-2.0 

* Sun Dec 27 2015 tomcat <> 1.5.11-5.git20151104
- update to git.20151104
- update Patch303 (show-input-mode-icon.patch)
- add Patch304,308 from openSUSE M17N repo.

* Sun Oct 18 2015 tomcat <> 1.5.11-4
- fix Requires

* Sat Oct 17 2015 tomcat <> 1.5.11-3
- rebuild

* Mon Aug 17 2015 tomcat <> 1.5.11-2
- fix typo of group in %%{libname}

* Sun Jul 19 2015 tomcat <> 1.5.11-1
- update to 1.5.11
- update Patch303 (show-input-mode-icon.patch)

* Mon May 25 2015 tomcat <> 1.5.10-3.git20150525
- git.20150525

* Sat Apr 11 2015 tomcat <> 1.5.10-2
- build with dconf-0.22.0
- update Patch303 (show-input-mode-icon.patch) from openSUSE

* Wed Feb 25 2015 tomcat <> 1.5.10-1
- update to 1.5.10

* Tue Jan 20 2015 tomcat <> 1.5.9-3.git20150106
- git 20150106
- drop Patch101,102 merged upstream

* Fri Dec 19 2014 tomcat <webmaster2@tomcat.nyanta.jp> 1.5.9-2.git20141218
- git 20141218
- add Patch101,102 from Fedora

* Tue Sep 16 2014 tomcat <webmaster2@tomcat.nyanta.jp> 1.5.9-1
- update to 1.5.9

* Fri Jul 25 2014 tomcat <webmaster2@tomcat.nyanta.jp> 1.5.8-1
- update to 1.5.8
- disable 'with_preload_xkb_engine'
- drop 'BR:python-gobject-devel, libGConf2-devel'
- drop Patch90 merged upstream
- drop Patch202, 203, 204
- drop Source203
- clean up SPEC file

* Mon May 12 2014 tomcat <webmaster2@tomcat.nyanta.jp> 1.5.7-0.3
- add --with-no-snooper-apps='' configure option

* Sat May 03 2014 tomcat <webmaster2@tomcat.nyanta.jp> 1.5.7-0.2
- add Patch90 from upstream
    Set max-width-chars property in ibus-setup wrapped GtkLabel. https://github.com/ibus/ibus/commit/0be4664b2ea3071c01ff479443033eb1accdfb03

* Wed Apr 30 2014 tomcat <webmaster2@tomcat.nyanta.jp> 1.5.7-0.1
- 1.5.7
- drop Patch201
- workaround for width of ibus-setup window

* Sat Apr 12 2014 tomcat <webmaster2@tomcat.nyanta.jp> 1.5.6-0.2
- add 'R:setime'

* Wed Apr 02 2014 tomcat <webmaster2@tomcat.nyanta.jp> 1.5.6-0.1
- 1.5.6
- update Patch202 (ibus-541492-xkb.patch)
- add Patch303 (show-input-mode-icon.patch) from openSUSE

* Thu Jan 30 2014 tomcat <webmaster2@tomcat.nyanta.jp> 1.5.5-0.1
- 1.5.5
- add Source203 from Fedora
- add Patch201,202,203,204 from Fedora
- drop Patch100
- fix '%%post gtk' and '%%postun gtk' sections
- add 'dconf update' into %%posttrans and %%postun sections
    'dconf update' need to work ibus-dconf

* Mon Dec 02 2013 tomcat <webmaster2@tomcat.nyanta.jp> 1.5.4-2.1
- do not use ibus-daemon-real

* Mon Nov 18 2013 billybot <billybot> 1.5.4-2pclos2013
- dont split out gir library files
- add BR python-gobject3-devel

* Sun Nov 10 2013 pinoc <vogtpet at gmail.com> 1.5.4-1pclos2013
- 1.5.4

